/***********************************************************************
 *
 * Copyright 2001 MontaVista Software Inc.
 * Author: jsun@mvista.com or jsun@junsun.net
 *
 * arch/mips/ddb5xxx/common/prom.c
 *     prom.c file.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 *
 ***********************************************************************
 */
#include <linux/config.h>
#include <linux/init.h>
#include <linux/mm.h>
#include <linux/sched.h>
#include <linux/bootmem.h>

#include <asm/addrspace.h>
#include <asm/bootinfo.h>
#include <asm/debug.h>
#include <asm/tcube.h>

//KOSE char arcs_cmdline[CL_SIZE];

const char *get_system_type(void)
{
	switch (mips_machtype) {
	}
	return 0;
}

/* [jsun@junsun.net] PMON passes arguments in C main() style */
//void __init prom_init(int argc, const char **argv)
void __init prom_init(void)
{
	int argc = fw_arg0;
	char **arg = (char**) fw_arg1;
	int i;

//const static char *p[] = { "", "nfsroot=192.168.0.8:/home/koseki/mipsel/","",
//  "ip=192.168.0.210::::hslvr1:eth0",0};
//const static char *p[] = { "", "nfsroot=192.168.0.8:/home/koseki/mipsel/","console=ttyS0,115200 console=tty0 video=smifb",
//const static char *p[] = { "", "nfsroot=192.168.0.8:/home/koseki/mipsel/","console=ttyS0,115200 console=tty0",
const static char *p[] = { "", "root=/dev/hda1","console=tty0 console=ttyS0,115200", "",0};
//const static char *p[] = { "", "root=/dev/mtdblock0","console=ttyS0,115200", "",0};
//const static char *p[] = { "","console=ttyS0,115200", 0};
//const static char *p[] = { "", "root=/dev/nfs nfsroot=192.168.0.8:/home/koseki/mipsel_041025xfree_install_bef/","console=tty0 console=ttyS0,115200",
//const static char *p[] = { "", "root=/dev/nfs nfsroot=192.168.0.8:/home/koseki/mipsel_041104_xfree_2.6.9_compile/","console=tty0 console=ttyS0,115200",
//  "ip=192.168.0.210:192.168.0.8:::hslvr1:eth0",0};
if(argc!=4){
  argc = 4 ;
  arg = (char **)p ;
}

	/* if user passes kernel args, ignore the default one */
	if (argc > 1)
		arcs_cmdline[0] = '\0';

	/* arg[0] is "g", the rest is boot parameters */
	for (i = 1; i < argc; i++) {
		if (strlen(arcs_cmdline) + strlen(arg[i] + 1)
		    >= sizeof(arcs_cmdline))
			break;
		strcat(arcs_cmdline, arg[i]);
		strcat(arcs_cmdline, " ");
	}

	mips_machgroup = MACH_GROUP_SHIMA_TCUBE;
	mips_machtype =  MACH_SHIMA_TCUBE;
	add_memory_region(0, TCUBE_SDRAM_SIZE, BOOT_MEM_RAM);
}

void __init prom_free_prom_memory(void)
{
}

int prom_get_para(const char *name,char **pValue)
{
	return 0;
}

int prom_get_int(const char *name, int *pVal)
{
/*const char *p,*n;
  unsigned int d[6];
  int i;*/
  char *v;
  
  if(prom_get_para(name, &v)){
    if(sscanf(v,"%d",pVal)<1)
      return 0;
    return 1;
  }
  return 0;
}

int prom_get_bool(const char *name, int *pVal)
{
/*const char *p,*n;
  unsigned int d[6];
  int i;*/
  char *v;
  
  if(prom_get_para(name, &v)){
    if(strcmp(v,"On")==0 ||strcmp(v,"on")==0 || v[0] == '1')
      *pVal = 1;
    else
      *pVal = 0;
    return 1;
  }
  return 0;
}

int prom_get_macadr(const char *name,u_char *mac_addr)
{
  /*const*/ char *v;
  unsigned int d[6];
  int i;

  /* printk("prom_get_macadr:name=%s\n",name); */
  if(prom_get_para(name, &v)){
    /* printk("prom_get_macadr:v=%s\n",v); */
    if(sscanf(v,"%x-%x-%x-%x-%x-%x",d,d+1,d+2,d+3,d+4,d+5) < 6)
      return 0;
    for(i=0;i<6;i++)
      mac_addr[i] = d[i];
    return 1;
  }
  return 0;
}


