//---------------------------------------------------------------
// hwclock for tcube-linux
//
//   gcc tcube_hwclock.c -o tcube_hwclock
//---------------------------------------------------------------

#include <unistd.h>		/* for close() */
#include <fcntl.h>		/* for O_RDONLY */
#include <sys/ioctl.h>

struct linux_rtc_time {
        int tm_sec;
        int tm_min;
        int tm_hour;
        int tm_mday;
        int tm_mon;
        int tm_year;
        int tm_wday;
        int tm_yday;
        int tm_isdst;
};

#define RTC_RD_TIME       _IOR('p', 0x09, struct linux_rtc_time)
#define RTC_SET_TIME      _IOW('p', 0x0a, struct linux_rtc_time)


/* maybe we should not try /dev/misc/efirtc?
   maybe we should reset rtc_dev_name to give better error messages */
int main(int argc , char **argv)
{
	int rtc_fd;
	struct linux_rtc_time tm ;
	int rc;
	if( argc != 1 && argc != 7){
		printf("set hwclock for tcube\n");
		printf("%s [return] --- show hwclock[YYYY MM DD HH MM SS]\n", argv[0]);
		printf("%s YYYY MM DD HH MM SS[return] --- set hwclock\n", argv[0]);
                exit(0);
	}
	rtc_fd = open("/dev/rtc", O_RDONLY);
	if (rtc_fd < 0) {
        	printf("Open Error \n");
        	exit(0);
	}
	if( argc == 1 ){
		rc = ioctl(rtc_fd, RTC_RD_TIME,  &tm);
		if( rc != 0 ) {
        		printf("RTC_RD_TIME Error \n");
	        	exit(0);
		}
		printf("%04d %02d %02d %02d %02d %02d\n", 
		  tm.tm_year, tm.tm_mon, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec );
//	        printf("tm_wday= %d\n",  tm.tm_wday);
//        	printf("tm_yday= %d\n",  tm.tm_yday);
//	        printf("tm_isdst= %d\n", tm.tm_isdst);
	}
	if( argc == 7 ){
		sscanf(argv[1],"%d", &tm.tm_year );
		sscanf(argv[2],"%d", &tm.tm_mon  );
		sscanf(argv[3],"%d", &tm.tm_mday );
		sscanf(argv[4],"%d", &tm.tm_hour );
		sscanf(argv[5],"%d", &tm.tm_min  );
		sscanf(argv[6],"%d", &tm.tm_sec  );
		rc = ioctl(rtc_fd, RTC_SET_TIME, &tm);
	}
	close(rtc_fd);
	return 0;
}

