/*
 * LynxEM+/EM4+(Silicon Motion Inc.) fb driver
 *			for VR41xx/VR5xxx.
 *
 * Copyright (C) NEC Corporation 2001, 2002.
 * Author: t-miwa@pi.jp.nec.co.jp
 *
 * THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
 * ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
 * PARTICULAR PURPOSE.
 *
 */
#ifndef __SMI_REGS_H__
#define __SMI_REGS_H__

/* register settings */
struct smi_mode_regs ModeInitParams[modeNums] = {
    /* mode#0 640 x 480 8Bpp 60Hz */
    {
	DISPLAY_640x480x8,
	/* reg_MISC */
	0xE3,
	/* reg_SR00_SR04 */
	{
	    0x03, 0x01, 0x0F, 0x00, 0x0E,                                      
	},
	/* reg_SR10_SR24 */
	{ 
	    0xFF, 0xBE, 0xEF, 0xFF, 0x00, 0x0E, 0x17, 0xe2,                    
	    0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0xC4, 0x30, 0x02, 0x01, 0x01,                                      
	},
	/* reg_SR30_SR75 */
	{
	    0x32, 0x03, 0xA0, 0x09, 0xC0, 0x32, 0x32, 0x32,                    
	    0x32, 0x32, 0x32, 0x32, 0x00, 0x00, 0x03, 0xFF,                    
	    0x00, 0xFC, 0x00, 0x00, 0x20, 0x18, 0x00, 0xFC,                    
	    0x20, 0x0C, 0x44, 0x20, 0x00, 0x32, 0x32, 0x32,                    
	    0x04, 0x24, 0x63, 0x4F, 0x52, 0x0B, 0xDF, 0xEA,                    
	    0x04, 0x50, 0x19, 0x32, 0x32, 0x00, 0x00, 0x32,                    
	    0x01, 0x80, 0x7E, 0x1A, 0x1A, 0x00, 0x00, 0x00,                    
	    0x50, 0x03, 0x74, 0x14, 0x07, 0x82, 0x07, 0x04,                    
	    0x00, 0x45, 0x30, 0x30, 0x40, 0x30,                                
	},
	/* reg_SR80_SR93 */
	{
	    0xFF, 0x07, 0x00, 0x6F, 0x7F, 0x7F, 0xFF, 0x32,                    
	    0xF7, 0x00, 0x00, 0x00, 0xEF, 0xFF, 0x32, 0x32,                    
	    0x00, 0x00, 0x00, 0x00,                                            
	},
	/* reg_SRA0_SRAF */
	{
	    0x00, 0xFF, 0xBF, 0xFF, 0xFF, 0xED, 0xED, 0xED,                    
	    0x7B, 0xFF, 0xFF, 0xFF, 0xBF, 0xEF, 0xFF, 0xDF,                    
	},
	/* reg_GR00_GR08 */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x05, 0x0F,                    
	    0xFF,                                                              
	},
	/* reg_AR00_AR14 */
	{
	    0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,                    
	    0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,                    
	    0x41, 0x00, 0x0F, 0x00, 0x00,                                      
	},
	/* reg_CR00_CR18 */
	{
	    0x5F, 0x4F, 0x4F, 0x00, 0x53, 0x1F, 0x0B, 0x3E,                    
	    0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0xEA, 0x0C, 0xDF, 0x50, 0x40, 0xDF, 0x00, 0xE3,                    
	    0xFF,                                                              
	},
	/* reg_CR30_CR4D */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x03, 0x20,                    
	    0x00, 0x00, 0x00, 0x40, 0x00, 0xE7, 0xFF, 0xFD,                    
	    0x5F, 0x4F, 0x00, 0x54, 0x00, 0x0B, 0xDF, 0x00,                    
	    0xEA, 0x0C, 0x2E, 0x00, 0x4F, 0xDF,                                
	},
	/* reg_CR90_CRA7 */
	{
	    0x56, 0xDD, 0x5E, 0xEA, 0x87, 0x44, 0x8F, 0x55,                    
	    0x0A, 0x8F, 0x55, 0x0A, 0x00, 0x00, 0x18, 0x00,                    
	    0x11, 0x10, 0x0B, 0x0A, 0x0A, 0x0A, 0x0A, 0x00,                    
	},
    },
    /* mode#1 800 x 600 8Bpp 60Hz */
    {
	DISPLAY_800x600x8,
	/* reg_MISC */
	0x2B,                                                                  
	/* reg_SR0_SR4 */ 
	{
	    0x03, 0x01, 0x0F, 0x03, 0x0E,                                      
	},
	/* reg_SR10_SR24 */
	{
	    0xFF, 0xBE, 0xEE, 0xFF, 0x00, 0x0E, 0x17, 0xe2,
	    0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	    0xC4, 0x30, 0x02, 0x01, 0x01,                    
	},
	/* reg_SR30_SR75 */
	{
	    0x36, 0x03, 0x20, 0x09, 0xC0, 0x36, 0x36, 0x36,                    
	    0x36, 0x36, 0x36, 0x36, 0x00, 0x00, 0x03, 0xFF,                    
	    0x00, 0xFC, 0x00, 0x00, 0x20, 0x18, 0x00, 0xFC,                    
	    0x20, 0x0C, 0x44, 0x20, 0x00, 0x36, 0x36, 0x36,                    
	    0x04, 0x48, 0x83, 0x63, 0x68, 0x72, 0x57, 0x58,                    
	    0x04, 0x55, 0x59, 0x36, 0x36, 0x00, 0x00, 0x36,                    
	    0x01, 0x80, 0x7E, 0x1A, 0x1A, 0x00, 0x00, 0x00,                    
	    0x50, 0x03, 0x74, 0x14, 0x1C, 0x85, 0x35, 0x13,                    
	    0x02, 0x45, 0x30, 0x30, 0x40, 0x20,                                
	},
	/* reg_SR80_SR93 */
	{
	    0xFF, 0x07, 0x00, 0x6F, 0x7F, 0x7F, 0xFF, 0x36,                    
	    0xF7, 0x00, 0x00, 0x00, 0xEF, 0xFF, 0x36, 0x36,                    
	    0x00, 0x00, 0x00, 0x00,                                            
	},
	/* reg_SRA0_SRAF */
	{
	    0x00, 0xFF, 0xBF, 0xFF, 0xFF, 0xED, 0xED, 0xED,                    
	    0x7B, 0xFF, 0xFF, 0xFF, 0xBF, 0xEF, 0xBF, 0xDF,                    
	},
	/* reg_GR00_GR08 */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x05, 0x0F,                    
	    0xFF,                                                              
	},
	/* reg_AR00_AR14 */
	{
	    0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,                    
	    0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,                    
	    0x41, 0x00, 0x0F, 0x00, 0x00,                                      
	},
	/* reg_CR00_CR18 */
	{   
	    0x7F, 0x63, 0x63, 0x00, 0x68, 0x18, 0x72, 0xF0,                    
	    0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0x58, 0x0C, 0x57, 0x64, 0x40, 0x57, 0x00, 0xE3,                    
	    0xFF,                                                              
	},
	/* reg_CR30_CR4D */
	{   
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x03, 0x20,                    
	    0x00, 0x00, 0x00, 0x40, 0x00, 0xE7, 0xBF, 0xFD,                    
	    0x7F, 0x63, 0x00, 0x69, 0x18, 0x72, 0x57, 0x00,                    
	    0x58, 0x0C, 0xE0, 0x20, 0x63, 0x57,                                
	},
	/*  reg_CR90_CRA7 */
	{
	    0x56, 0x4B, 0x5E, 0x55, 0x86, 0x9D, 0x8E, 0xAA,                    
	    0xDB, 0x2A, 0xDF, 0x33, 0x00, 0x00, 0x18, 0x00,                    
	    0x20, 0x1F, 0x1A, 0x19, 0x0F, 0x0F, 0x0F, 0x00,                    
	},
    },
    /* mode#2 1024 x 768 8Bpp 60Hz */
    {
	DISPLAY_1024x768x8,
	/* reg_MISC */
	0xEB,                                                                  
	/* reg_SR00_SR04 */
	{
	    0x03, 0x01, 0x0F, 0x03, 0x0E,                                      
	},
	/* reg_SR10_SR24 */
	{
	    0xF3, 0xB6, 0xC0, 0xDD, 0x00, 0x0E, 0x17, 0xe2,
	    0xff, 0x02, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0xC4, 0x30, 0x02, 0x01, 0x01,                                      
	},
	/* reg_SR30_SR75 */
	{
	    0x3A, 0x03, 0x20, 0x09, 0xC0, 0x3A, 0x3A, 0x3A,                    
	    0x3A, 0x3A, 0x3A, 0x3A, 0x00, 0x00, 0x03, 0xFF,                    
	    0x00, 0xFC, 0x00, 0x00, 0x20, 0x18, 0x00, 0xFC,                    
	    0x20, 0x0C, 0x44, 0x20, 0x00, 0x3A, 0x3A, 0x3A,                    
	    0x06, 0x68, 0xA7, 0x7F, 0x83, 0x24, 0xFF, 0x03,                    
	    0x00, 0x60, 0x59, 0x3A, 0x3A, 0x00, 0x00, 0x3A,                    
	    0x01, 0x80, 0x7E, 0x1A, 0x1A, 0x00, 0x00, 0x00,                    
	    0x50, 0x03, 0x74, 0x14, 0x12, 0x82, 0x09, 0x02,                    
	    0x04, 0x45, 0x30, 0x30, 0x40, 0x20,                                
	},
	/* reg_SR80_SR93 */
	{
	    0xFF, 0x07, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x3A,                    
	    0xF7, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0x3A, 0x3A,                    
	    0x00, 0x00, 0x00, 0x00,                                            
	},
	/* reg_SRA0_SRAF */
	{
	    0x00, 0xFB, 0x9F, 0x01, 0x00, 0xED, 0xED, 0xED,                    
	    0x7B, 0xFB, 0xFF, 0xFF, 0x97, 0xEF, 0xBF, 0xDF,                    
	},
	/* reg_GR00_GR08 */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x05, 0x0F,                    
	    0xFF,                                                              
	},
	/* reg_AR00_AR14 */
	{
	    0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,                    
	    0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,                    
	    0x41, 0x00, 0x0F, 0x00, 0x00,                                      
	},
	/* reg_CR00_CR18 */
	{
	    0xA3, 0x7F, 0x7F, 0x00, 0x85, 0x16, 0x24, 0xF5,                    
	    0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0x03, 0x09, 0xFF, 0x80, 0x40, 0xFF, 0x00, 0xE3,                    
	    0xFF,                                                              
	},
	/* reg_CR30_CR4D */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x02, 0x20,                    
	    0x00, 0x00, 0x00, 0x40, 0x00, 0xFF, 0xBF, 0xFF,                    
	    0xA3, 0x7F, 0x00, 0x86, 0x15, 0x24, 0xFF, 0x00,                    
	    0x01, 0x07, 0xE5, 0x20, 0x7F, 0xFF,                                
	},
	/* reg_CR90_CRA7 */
	{
	    0x55, 0xD9, 0x5D, 0xE1, 0x86, 0x1B, 0x8E, 0x26,                    
	    0xDA, 0x8D, 0xDE, 0x94, 0x00, 0x00, 0x18, 0x00,                    
	    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x15, 0x03,                    
	},
    },
    /* mode#3 1280x1024 8Bpp 60Hz */
    {
	DISPLAY_1280x1024x8,
	/* reg_MISC */
	0x2B,                                                                  
	/* reg_SR00_SR04 */
	{
	    0x03, 0x01, 0x0F, 0x03, 0x0E,                                      
	},
	/* reg_SR10_SR24 */
	{
	    0x20, 0x0C, 0x00, 0x00, 0x00, 0x0E, 0x17, 0xe2,
	    0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0xC4, 0x30, 0x02, 0x00, 0x01,                                      
	},
	/* reg_SR30_SR75 */
	{
	    0x4E, 0x03, 0xA0, 0x09, 0xC0, 0x3A, 0x3A, 0x3A,                    
	    0xFF, 0x00, 0xFC, 0x3A, 0x00, 0x00, 0x03, 0xFF,                    
	    0x00, 0xFC, 0x00, 0x00, 0x20, 0x38, 0x00, 0xFC,                    
	    0x20, 0x1C, 0xA1, 0x20, 0x00, 0x3A, 0x3A, 0x3A,                    
	    0x08, 0x8C, 0xD3, 0x9F, 0xA8, 0x29, 0xFF, 0x01,                    
	    0x00, 0x65, 0x59, 0x3A, 0x3A, 0x00, 0x00, 0x3A,                    
	    0x00, 0x00, 0xFF, 0x1A, 0x1A, 0x00, 0x00, 0x00,                    
	    0x40, 0x04, 0x74, 0x14, 0x53, 0x0B, 0x53, 0x0B,                    
	    0x86, 0x8D, 0x0E, 0x35, 0x05, 0x00,                                
	},
	/* reg_SR80_SR93 */
	{
	    0xFF, 0x07, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x3A,                    
	    0xF7, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0x3A, 0x3A,                    
	    0x00, 0x00, 0x00, 0x00,                                            
	},
	/* reg_SRA0_SRAF */
	{
	    0x00, 0x11, 0x14, 0x01, 0x00, 0xED, 0xED, 0xED,                    
	    0x06, 0x03, 0x44, 0x00, 0x0B, 0x29, 0x00, 0x84,                    
	},
	/* reg_GR00_GR08 */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x05, 0x0F,                    
	    0xFF,                                                              
	},
	/* reg_AR00_AR14 */
	{
	    0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,                    
	    0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,                    
	    0x41, 0x00, 0x0F, 0x00, 0x00,                                      
	},
	/* reg_CR00_CR18 */
	{
	    0xCE, 0x9F, 0x9F, 0x00, 0xA7, 0x15, 0x28, 0x5A,                    
	    0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0x00, 0xA3, 0xFF, 0xA0, 0x00, 0xFF, 0x00, 0xE3,                    
	    0xFF,                                                              
	},
	/* reg_CR30_CR4D */
	{
	    0x09, 0x00, 0x00, 0x00, 0x00, 0x80, 0x02, 0x00,                    
	    0x00, 0x00, 0x28, 0x40, 0x00, 0x00, 0x49, 0x1D,                    
	    0xCE, 0x9F, 0x00, 0xA7, 0x15, 0x28, 0xFF, 0x00,                    
	    0x00, 0x03, 0x4A, 0x20, 0x9F, 0xFF,                                
	},
	/* reg_CR90_CRA7 */
	{
	    0x55, 0xCA, 0x5E, 0xD2, 0x86, 0x0A, 0x8E, 0x15,                    
	    0x57, 0x20, 0xFF, 0x00, 0x00, 0x00, 0x18, 0x00,                    
	    0x3F, 0x3F, 0x3F, 0x3F, 0x35, 0x20, 0x3F, 0x28,                    
	},
    },
    /* mode#4 640 x 480 16Bpp 60Hz */
    {
	DISPLAY_640x480x16,
	/* reg_MISC */
	0xE3,                                                                  
	/* reg_SR00_SR04 */
	{
	    0x03, 0x01, 0x0F, 0x00, 0x0E,                                      
	},
	/* reg_SR10_SR24 */
	{
	    0xFF, 0xBE, 0xEF, 0xFF, 0x00, 0x0E, 0x17, 0xe2,
	    0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	    0xC4, 0x30, 0x02, 0x01, 0x01,
	},
	/* reg_SR30_SR75 */
	{
	    0x32, 0x03, 0xA0, 0x09, 0xC0, 0x32, 0x32, 0x32,                    
	    0x32, 0x32, 0x32, 0x32, 0x00, 0x00, 0x03, 0xFF,                    
	    0x00, 0xFC, 0x00, 0x00, 0x20, 0x18, 0x00, 0xFC,                    
	    0x20, 0x0C, 0x44, 0x20, 0x00, 0x32, 0x32, 0x32,                    
	    0x04, 0x24, 0x63, 0x4F, 0x52, 0x0B, 0xDF, 0xEA,                    
	    0x04, 0x50, 0x19, 0x32, 0x32, 0x00, 0x00, 0x32,                    
	    0x01, 0x80, 0x7E, 0x1A, 0x1A, 0x00, 0x00, 0x00,                    
	    0x50, 0x03, 0x74, 0x14, 0x07, 0x82, 0x07, 0x04,                    
	    0x00, 0x45, 0x30, 0x30, 0x40, 0x30,                                
	},
	/* reg_SR80_SR93 */
	{
	    0xFF, 0x07, 0x00, 0x6F, 0x7F, 0x7F, 0xFF, 0x32,                    
	    0xF7, 0x00, 0x00, 0x00, 0xEF, 0xFF, 0x32, 0x32,                    
	    0x00, 0x00, 0x00, 0x00,                                            
	},
	/* reg_SRA0_SRAF */
	{
	    0x00, 0xFF, 0xBF, 0xFF, 0xFF, 0xED, 0xED, 0xED,                    
	    0x7B, 0xFF, 0xFF, 0xFF, 0xBF, 0xEF, 0xFF, 0xDF,                    
	},
	/* reg_GR00_GR08 */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x05, 0x0F,                    
	    0xFF,                                                              
	},
	/* reg_AR00_AR14 */
	{
	    0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,                    
	    0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,                    
	    0x41, 0x00, 0x0F, 0x00, 0x00,                                      
	},
	/* reg_CR00_CR18 */
	{
	    0x5F, 0x4F, 0x4F, 0x00, 0x53, 0x1F, 0x0B, 0x3E,                    
	    0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0xEA, 0x0C, 0xDF, 0x50, 0x40, 0xDF, 0x00, 0xE3,                    
	    0xFF,                                                              
	},
	/* reg_CR30_CR4D */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x03, 0x20,                    
	    0x00, 0x00, 0x00, 0x40, 0x00, 0xE7, 0xFF, 0xFD,                    
	    0x5F, 0x4F, 0x00, 0x54, 0x00, 0x0B, 0xDF, 0x00,                    
	    0xEA, 0x0C, 0x2E, 0x00, 0x4F, 0xDF,                                
	},
	/* reg_CR90_CRA7 */
	{
	    0x56, 0xDD, 0x5E, 0xEA, 0x87, 0x44, 0x8F, 0x55,                    
	    0x0A, 0x8F, 0x55, 0x0A, 0x00, 0x00, 0x18, 0x00,                    
	    0x11, 0x10, 0x0B, 0x0A, 0x0A, 0x0A, 0x0A, 0x00,                    
	},
    },
    /* mode#5 800 x 600 16Bpp 60Hz */
    {
	DISPLAY_800x600x16,
	/* reg_MISC */
	0x2B,                                                                  
	/* reg_SR00_SR04 */
	{
	    0x03, 0x01, 0x0F, 0x03, 0x0E,                                      
	},
	/* reg_SR10_SR24 */
	{
	    0xFF, 0xBE, 0xEE, 0xFF, 0x00, 0x0E, 0x17, 0xe2,                    
	    0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0xC4, 0x30, 0x02, 0x01, 0x01,                                      
	},
	/* reg_SR30_SR75 */
	{
	    0x36, 0x03, 0x20, 0x09, 0xC0, 0x36, 0x36, 0x36,                    
	    0x36, 0x36, 0x36, 0x36, 0x00, 0x00, 0x03, 0xFF,                    
	    0x00, 0xFC, 0x00, 0x00, 0x20, 0x18, 0x00, 0xFC,                    
	    0x20, 0x0C, 0x44, 0x20, 0x00, 0x36, 0x36, 0x36,                    
	    0x04, 0x48, 0x83, 0x63, 0x68, 0x72, 0x57, 0x58,                    
	    0x04, 0x55, 0x59, 0x36, 0x36, 0x00, 0x00, 0x36,                    
	    0x01, 0x80, 0x7E, 0x1A, 0x1A, 0x00, 0x00, 0x00,                    
	    0x50, 0x03, 0x74, 0x14, 0x1C, 0x85, 0x35, 0x13,                    
	    0x02, 0x45, 0x30, 0x30, 0x40, 0x20,                                
	},
	/* reg_SR80_SR93 */
	{
	    0xFF, 0x07, 0x00, 0x6F, 0x7F, 0x7F, 0xFF, 0x36,                    
	    0xF7, 0x00, 0x00, 0x00, 0xEF, 0xFF, 0x36, 0x36,                    
	    0x00, 0x00, 0x00, 0x00,                                            
	},
	/* reg_SRA0_SRAF */
	{
	    0x00, 0xFF, 0xBF, 0xFF, 0xFF, 0xED, 0xED, 0xED,                    
	    0x7B, 0xFF, 0xFF, 0xFF, 0xBF, 0xEF, 0xBF, 0xDF,                    
	},
	/* reg_GR00_GR08 */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x05, 0x0F,                    
	    0xFF,                                                              
	},
	/* reg_AR00_AR14 */
	{
	    0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,                    
	    0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,                    
	    0x41, 0x00, 0x0F, 0x00, 0x00,                                      
	},
	/* reg_CR00_CR18 */
	{
	    0x7F, 0x63, 0x63, 0x00, 0x68, 0x18, 0x72, 0xF0,                    
	    0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0x58, 0x0C, 0x57, 0x64, 0x40, 0x57, 0x00, 0xE3,                    
	    0xFF,                                                              
	},
	/* reg_CR30_CR4D */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x03, 0x20,                    
	    0x00, 0x00, 0x00, 0x40, 0x00, 0xE7, 0xBF, 0xFD,                    
	    0x7F, 0x63, 0x00, 0x69, 0x18, 0x72, 0x57, 0x00,                    
	    0x58, 0x0C, 0xE0, 0x20, 0x63, 0x57,                                
	},
	/* reg_CR90_CRA7 */
	{
	    0x56, 0x4B, 0x5E, 0x55, 0x86, 0x9D, 0x8E, 0xAA,                    
	    0xDB, 0x2A, 0xDF, 0x33, 0x00, 0x00, 0x18, 0x00,                    
	    0x20, 0x1F, 0x1A, 0x19, 0x0F, 0x0F, 0x0F, 0x00,                    
	},
    },
    /* mode#6 1024 x 768 16Bpp 60Hz */
    {
	DISPLAY_1024x768x16,
	/* reg_MISC */
	0xEB,                                                                  
	/* reg_SR00_SR04 */
	{
	    0x03, 0x01, 0x0F, 0x03, 0x0E,                                      
	},
	/* reg_SR10_SR24 */
	{
	    0xF3, 0xB6, 0xC0, 0xDD, 0x00, 0x0E, 0x17, 0xe2,                    
	    0xff, 0x02, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0xC4, 0x30, 0x02, 0x01, 0x01,                                      
	},
	/* reg_SR30_SR75 */
	{
	    0x3A, 0x03, 0x20, 0x09, 0xC0, 0x3A, 0x3A, 0x3A,                    
	    0x3A, 0x3A, 0x3A, 0x3A, 0x00, 0x00, 0x03, 0xFF,                    
	    0x00, 0xFC, 0x00, 0x00, 0x20, 0x18, 0x00, 0xFC,                    
	    0x20, 0x0C, 0x44, 0x20, 0x00, 0x3A, 0x3A, 0x3A,                    
	    0x06, 0x68, 0xA7, 0x7F, 0x83, 0x24, 0xFF, 0x03,                    
	    0x00, 0x60, 0x59, 0x3A, 0x3A, 0x00, 0x00, 0x3A,                    
	    0x01, 0x80, 0x7E, 0x1A, 0x1A, 0x00, 0x00, 0x00,                    
	    0x50, 0x03, 0x74, 0x14, 0x12, 0x82, 0x09, 0x02,                    
	    0x04, 0x45, 0x30, 0x30, 0x40, 0x20,                                
	},
	/* reg_SR80_SR93 */
	{
	    0xFF, 0x07, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x3A,                    
	    0xF7, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0x3A, 0x3A,                    
	    0x00, 0x00, 0x00, 0x00,                                            
	},
	/* reg_SRA0_SRAF */
	{
	    0x00, 0xFB, 0x9F, 0x01, 0x00, 0xED, 0xED, 0xED,                    
	    0x7B, 0xFB, 0xFF, 0xFF, 0x97, 0xEF, 0xBF, 0xDF,                    
	},
	/* reg_GR00_GR08 */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x05, 0x0F,                    
	    0xFF,                                                              
	},
	/* reg_AR00_AR14 */
	{
	    0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,                    
	    0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,                    
	    0x41, 0x00, 0x0F, 0x00, 0x00,                                      
	},
	/* reg_CR00_CR18 */
	{
	    0xA3, 0x7F, 0x7F, 0x00, 0x85, 0x16, 0x24, 0xF5,                    
	    0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0x03, 0x09, 0xFF, 0x80, 0x40, 0xFF, 0x00, 0xE3,                    
	    0xFF,                                                              
	},
	/* reg_CR30_CR4D */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x02, 0x20,                    
	    0x00, 0x00, 0x00, 0x40, 0x00, 0xFF, 0xBF, 0xFF,                    
	    0xA3, 0x7F, 0x00, 0x86, 0x15, 0x24, 0xFF, 0x00,                    
	    0x01, 0x07, 0xE5, 0x20, 0x7F, 0xFF,                                
	},
	/* reg_CR90_CRA7 */
	{
	    0x55, 0xD9, 0x5D, 0xE1, 0x86, 0x1B, 0x8E, 0x26,                    
	    0xDA, 0x8D, 0xDE, 0x94, 0x00, 0x00, 0x18, 0x00,                    
	    0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x15, 0x03,                    
	},
    },
    /* mode#7 640 x 480 24Bpp 60Hz */
    {
	DISPLAY_640x480x24,
	/* reg_MISC */
	0xE3,                                                                  
	/* reg_SR00_SR04 */
	{
	    0x03, 0x01, 0x0F, 0x00, 0x0E,                                      
	},
	/* reg_SR10_SR24 */
	{
	    0xFF, 0xBE, 0xEF, 0xFF, 0x00, 0x0E, 0x17, 0xe2,                    
	    0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0xC4, 0x30, 0x02, 0x01, 0x01,                                      
	},
	/* reg_SR30_SR75 */
	{
	    0x32, 0x03, 0xA0, 0x09, 0xC0, 0x32, 0x32, 0x32,                    
	    0x32, 0x32, 0x32, 0x32, 0x00, 0x00, 0x03, 0xFF,                    
	    0x00, 0xFC, 0x00, 0x00, 0x20, 0x18, 0x00, 0xFC,                    
	    0x20, 0x0C, 0x44, 0x20, 0x00, 0x32, 0x32, 0x32,                    
	    0x04, 0x24, 0x63, 0x4F, 0x52, 0x0B, 0xDF, 0xEA,                    
	    0x04, 0x50, 0x19, 0x32, 0x32, 0x00, 0x00, 0x32,                    
	    0x01, 0x80, 0x7E, 0x1A, 0x1A, 0x00, 0x00, 0x00,                    
	    0x50, 0x03, 0x74, 0x14, 0x07, 0x82, 0x07, 0x04,                    
	    0x00, 0x45, 0x30, 0x30, 0x40, 0x30,                                
	},
	/* reg_SR80_SR93 */
	{
	    0xFF, 0x07, 0x00, 0x6F, 0x7F, 0x7F, 0xFF, 0x32,                    
	    0xF7, 0x00, 0x00, 0x00, 0xEF, 0xFF, 0x32, 0x32,                    
	    0x00, 0x00, 0x00, 0x00,                                            
	},
	/* reg_SRA0_SRAF */
	{
	    0x00, 0xFF, 0xBF, 0xFF, 0xFF, 0xED, 0xED, 0xED,                    
	    0x7B, 0xFF, 0xFF, 0xFF, 0xBF, 0xEF, 0xFF, 0xDF,                    
	},
	/* reg_GR00_GR08 */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x05, 0x0F,                    
	    0xFF,                                                              
	},
	/* reg_AR00_AR14 */
	{
	    0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,                    
	    0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,                    
	    0x41, 0x00, 0x0F, 0x00, 0x00,                                      
	},
	/* reg_CR00_CR18 */
	{
	    0x5F, 0x4F, 0x4F, 0x00, 0x53, 0x1F, 0x0B, 0x3E,                    
	    0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0xEA, 0x0C, 0xDF, 0x50, 0x40, 0xDF, 0x00, 0xE3,                    
	    0xFF,                                                              
	},
	/* reg_CR30_CR4D */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x03, 0x20,                    
	    0x00, 0x00, 0x00, 0x40, 0x00, 0xE7, 0xFF, 0xFD,                    
	    0x5F, 0x4F, 0x00, 0x54, 0x00, 0x0B, 0xDF, 0x00,                    
	    0xEA, 0x0C, 0x2E, 0x00, 0x4F, 0xDF,                                
	},
	/* reg_CR90_CRA7 */
	{
	    0x56, 0xDD, 0x5E, 0xEA, 0x87, 0x44, 0x8F, 0x55,                    
	    0x0A, 0x8F, 0x55, 0x0A, 0x00, 0x00, 0x18, 0x00,                    
	    0x11, 0x10, 0x0B, 0x0A, 0x0A, 0x0A, 0x0A, 0x00,                    
	},
    },
    /* mode#8 800 x 600 24Bpp 60Hz */
    {
	DISPLAY_800x600x24,
	/* reg_MISC */
	0x2B,                                                                  
	/* reg_SR00_SR04 */
	{
	    0x03, 0x01, 0x0F, 0x03, 0x0E,                                      
	},
	/* reg_SR10_SR24 */
	{
	    0xFF, 0xBE, 0xEE, 0xFF, 0x00, 0x0E, 0x17, 0xe2,                    
	    0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0xC4, 0x30, 0x02, 0x01, 0x01,                                      
	},
	/* reg_SR30_SR75 */
	{
	    0x36, 0x03, 0x20, 0x09, 0xC0, 0x36, 0x36, 0x36,                    
	    0x36, 0x36, 0x36, 0x36, 0x00, 0x00, 0x03, 0xFF,                    
	    0x00, 0xFC, 0x00, 0x00, 0x20, 0x18, 0x00, 0xFC,                    
	    0x20, 0x0C, 0x44, 0x20, 0x00, 0x36, 0x36, 0x36,                    
	    0x04, 0x48, 0x83, 0x63, 0x68, 0x72, 0x57, 0x58,                    
	    0x04, 0x55, 0x59, 0x36, 0x36, 0x00, 0x00, 0x36,                    
	    0x01, 0x80, 0x7E, 0x1A, 0x1A, 0x00, 0x00, 0x00,                    
	    0x50, 0x03, 0x74, 0x14, 0x1C, 0x85, 0x35, 0x13,                    
	    0x02, 0x45, 0x30, 0x30, 0x40, 0x20,                                
	},
	/* reg_SR80_SR93 */
	{
	    0xFF, 0x07, 0x00, 0x6F, 0x7F, 0x7F, 0xFF, 0x36,                    
	    0xF7, 0x00, 0x00, 0x00, 0xEF, 0xFF, 0x36, 0x36,                    
	    0x00, 0x00, 0x00, 0x00,                                            
	},
	/* reg_SRA0_SRAF */
	{
	    0x00, 0xFF, 0xBF, 0xFF, 0xFF, 0xED, 0xED, 0xED,                    
	    0x7B, 0xFF, 0xFF, 0xFF, 0xBF, 0xEF, 0xBF, 0xDF,                    
	},
	/* reg_GR00_GR08 */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x05, 0x0F,                    
	    0xFF,                                                              
	},
	/* reg_AR00_AR14 */
	{
	    0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,                    
	    0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,                    
	    0x41, 0x00, 0x0F, 0x00, 0x00,                                      
	},
	/* reg_CR00_CR18 */
	{
	    0x7F, 0x63, 0x63, 0x00, 0x68, 0x18, 0x72, 0xF0,                    
	    0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                    
	    0x58, 0x0C, 0x57, 0x64, 0x40, 0x57, 0x00, 0xE3,                    
	    0xFF,                                                              
	},
	/* reg_CR30_CR4D */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x03, 0x20,                    
	    0x00, 0x00, 0x00, 0x40, 0x00, 0xE7, 0xBF, 0xFD,                    
	    0x7F, 0x63, 0x00, 0x69, 0x18, 0x72, 0x57, 0x00,                    
	    0x58, 0x0C, 0xE0, 0x20, 0x63, 0x57,                                
	},
	/* reg_CR90_CRA7 */
	{
	    0x56, 0x4B, 0x5E, 0x55, 0x86, 0x9D, 0x8E, 0xAA,                    
	    0xDB, 0x2A, 0xDF, 0x33, 0x00, 0x00, 0x18, 0x00,                    
	    0x20, 0x1F, 0x1A, 0x19, 0x0F, 0x0F, 0x0F, 0x00,                    
	},
    },
    /* mode#9 400 x 232 16Bpp 60Hz */
    {
	DISPLAY_LCD_400x232x16,
	/* reg_MISC */
	0x2B,                                                                  
	/* reg_SR00_SR04 */
	{
	    0x03, 0x01, 0x0F, 0x03, 0x0E, 
	},
	/* reg_SR10_SR24 */
	{
	    0x03, 0x00, 0x00, 0x00, 0x00, 0x08, 0x10, 0x2C,
	    0x59, 0x00, 0x00, 0x00, 0x00, 0x0F, 0x0F, 0x00,
	    0x84, 0x00, 0x02, 0x00, 0x31, 
	},
	/* reg_SR30_SR75 */
	{
	    0xB7, 0x43, 0x98, 0x01, 0xC0, 0xB7, 0xB7, 0xB7,
	    0xB7, 0xB7, 0xB7, 0xB7, 0x00, 0x00, 0x85, 0x2C,
	    0xC0, 0xE1, 0x00, 0x00, 0x40, 0xF0, 0x80, 0xC4,
	    0x40, 0x3C, 0xA1, 0x40, 0x00, 0x00, 0x01, 0xB7,
	    0x02, 0x24, 0xD9, 0xC7, 0xCC, 0x31, 0x2C, 0x2D,
	    0x07, 0x57, 0x19, 0xB7, 0xB7, 0x00, 0x00, 0xB7,
	    0x01, 0x00, 0xFF, 0x1A, 0x1A, 0x01, 0x03, 0x00,
	    0xD4, 0x07, 0x0D, 0x02, 0x23, 0x3F, 0x35, 0x13,
	    0x83, 0xDD, 0x02, 0x0C, 0x05, 0x00, 
	},
	/* reg_SR80_SR93 */
	{
	    0xFF, 0x0F, 0x00, 0x00, 0x00, 0x00, 0x09, 0xB7,
	    0x48, 0x00, 0x36, 0x00, 0xFF, 0x00, 0xB7, 0xB7,
	    0x00, 0x00, 0x00, 0x00,
	},
	/* reg_SRA0_SRAF */
	{
	    0x00, 0xFF, 0xBF, 0xFF, 0xFF, 0xED, 0xED, 0xED,
	    0x7B, 0xFF, 0xFF, 0xFF, 0xBF, 0xEF, 0xBF, 0xDF, 
	},
	/* reg_GR00_GR08 */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x05, 0x0F,
	    0xFF, 
	},
	/* reg_AR00_AR14 */
	{
	    0x00, 0x02, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
	    0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
	    0x10, 0x00, 0x12, 0x00, 0x04, 
	},
	/* reg_CR00_CR18 */
	{
	    0x3B, 0x31, 0x31, 0x00, 0x3A, 0x00, 0x06, 0x11,
	    0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	    0xF1, 0x85, 0xE9, 0x32, 0x40, 0xE9, 0x00, 0xEB,
	    0xFF, 
	},
	/* reg_CR30_CR4D */
	{
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x88, 0x02, 0x10,
	    0x00, 0x00, 0x00, 0x40, 0x00, 0x20, 0x00, 0x00,
	    0x3B, 0x31, 0x00, 0x3A, 0x00, 0x06, 0xEA, 0x00,
	    0xF2, 0x05, 0x01, 0x00, 0x31, 0xE9, 
	},
	/* reg_CR90_CRA7 */
	{
	    0x56, 0x4B, 0x5E, 0x55, 0x86, 0x9D, 0x8E, 0xAA,
	    0xDB, 0x2A, 0xDF, 0x33, 0xFF, 0xFF, 0x1B, 0x00,
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
	},
    },
};



#endif /* __SMI_REGS_H__ */
